#!/bin/bash
EXE_DIR=/usr/local/bin
EXE_FILE=ups.sh
CONF_FILE=ups.conf
LIB_FILE=ups.lib
INSTALL_DIR=/opt/ups
INS_FILE=install.sh
SCRIPTS=scripts
DAEMON=ups_turn_off.sh



if [ $# -eq 0 ]
then
	echo "Please enter command line argument -install or -uninstall"
	exit 0
fi

#uninstall
if [ $1 = "-uninstall" ]
then

	echo "Stopping auto turn off daemon"
	pkill $DAEMON
	 
	echo "Cleaning up /ect/rc.local"
	sed --in-place "/$DAEMON/d" /etc/rc.local
	
	echo "Removing $EXE_FILE from $EXE_DIR"
	rm $EXE_DIR/$EXE_FILE

  echo "Deleting installation directory $INSTALL_DIR"
	rm -r $INSTALL_DIR
	
	echo "Software has been uninstalled."
	exit 0

#install
elif [ $1 = "-install" ]
then
	
	if [ -e $INSTALL_DIR ]
	then
		echo "software already installed in $INSTALL_DIR, deleting directory."
		echo "Stopping auto turn off daemon"
		pkill $DAEMON
		rm -r $INSTALL_DIR
	fi
	
	echo "Installing UPS software into $INSTALL_DIR"
	mkdir $INSTALL_DIR
	cp $CONF_FILE $INSTALL_DIR
	chmod 666 $INSTALL_DIR/$CONF_FILE
	cp $LIB_FILE $INSTALL_DIR
	chmod 777 $INSTALL_DIR/$LIB_FILE
	cp $EXE_FILE $EXE_DIR
	chmod 777 $EXE_DIR/$EXE_FILE
	cp $INS_FILE $INSTALL_DIR
	chmod 777 $INSTALL_DIR/$INS_FILE
	cp -r $SCRIPTS $INSTALL_DIR
	chmod 777 $INSTALL_DIR/$SCRIPTS/$DAEMON
	

  	if [ -e /etc/rc.local ]
 	then
 		echo "Modifying /etc/rc.local"
 		sed --in-place "/$DAEMON/d" /etc/rc.local
		sed --in-place '/exit/d' /etc/rc.local
		echo "$INSTALL_DIR/$SCRIPTS/$DAEMON" >> /etc/rc.local
		echo "exit 0" >> /etc/rc.local
 	
	else
		echo "/etc/rc.local not found, creating it"
		echo "#!/bin/sh -e" >> /etc/rc.local
 		echo "$INSTALL_DIR/$SCRIPTS/$DAEMON" >> /etc/rc.local
 		echo "exit 0" >> /etc/rc.local
 		chmod 777 /etc/rc.local	 
	fi
	
	#Run i2c_find to update i2c address in the .conf file
	ups.sh -i2c_find
	
	#start the deamon
	echo "Starting auto turn off daemon"
	$INSTALL_DIR/$SCRIPTS/$DAEMON &
	
	echo "Software has been installed."
	exit 0
	
else
	echo "Invalid command line argument, please use -help to see valid arguments"
	exit 1
fi
	
	